setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13')
source('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/00_master.R')
library(soundgen)
library(seewave)

path = '/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/'

path = '~/Downloads/'

## VISUAL
s = sliceLab(constraints = list(L = 53)) 
s = sliceLab(constraints = list(L = 53, b = 50)) 
saveLab(col_lab = c(53, -40, 50), 
        filename = 'L53_a-40_b50',
        path = path, width = 800, height = 800)
saveLab(col_lab = c(50, 40, 45), 
        filename = 'L50_a40_b45',
        path = path, width = 800, height = 800)

plot(x = 1:10, y = 1:10, type = 'n')
points(5, 5, col='red', pch = 16, cex = 100)
col2rgb('red')
x = matrix(col2rgb('red'), nrow = 1) / 255
convertColor(x, from = 'sRGB', to = 'Lab')


## AUDITORY
F1_a_high = soundgen(sylLen = 350, pitchAnchors = c(160, 200, 160), formants = list(f1 = 790, f2 = 1900, f3 = 3160, f4 = 4430), vocalTract = 14, attackLen = 50, rolloff = -9, mouthAnchors = c(.5, .6, .5), noiseAnchors = data.frame(time = c(0, 400, 450), value = c(-40, -40, -80) + 10), rolloffNoise = -9, play = TRUE, invalidArgAction = 'ignore', plot = T, temperature = .001)
seewave::meanspec(F1_a_high, f = 16000, dB = 'max0')

F1_a_low = soundgen(sylLen = 350, pitchAnchors = c(160, 200, 160), formants = list(f1 = 500, f2 = 1900, f3 = 3160, f4 = 4430), vocalTract = 14, attackLen = 50, rolloff = -7, mouthAnchors = c(.5, .6, .5), noiseAnchors = data.frame(time = c(0, 400, 450), value = c(-40, -40, -80) + 10), rolloffNoise = -9, play = TRUE, invalidArgAction = 'ignore', plot = T, temperature = .001)
seewave::meanspec(F1_a_low, f = 16000, dB = 'max0')  # manually adjust rolloff to have ~the same spectral slope as in F1_a_01_low


# dynamic sounds
# F1 changes by ±4 semitones (either 4 semitones up from neutral or 4 semitones down)
F1_neutralHigh = soundgen(sylLen = 350, pitchAnchors = c(160, 200, 160), formants = list(f1 = c(630, 790), f2 = 1900, f3 = 3160, f4 = 4430), vocalTract = 14, attackLen = 50, rolloff = c(-8, -9), mouthAnchors = c(.5, .6, .5), noiseAnchors = data.frame(time = c(0, 400, 450), value = c(-40, -40, -80) + 10), rolloffNoise = -9, play = TRUE, invalidArgAction = 'ignore', plot = T, temperature = .001)
seewave::meanspec(F1_neutralHigh, f = 16000, dB = 'max0')
spectrogram(F1_neutralHigh, 16000, ylim = c(0, 5))
seewave::savewav(F1_neutralHigh, f = 16000, filename = paste0(path, 'F1_neutralHigh.wav'))
system("ffmpeg -i /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/F1_neutralHigh.wav -b:a 128k /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/F1_neutralHigh.mp3")

s1 = seewave::spec(F1_neutralHigh, f = 16000, dB = NULL)
w = s1[, 2] / sum(s1[, 2])
sum(s1[, 1] * w) * 1000  # spectral centroid = 1384 Hz



F1_neutralLow = soundgen(sylLen = 350, pitchAnchors = c(160, 200, 160), formants = list(f1 = c(630, 500), f2 = 1900, f3 = 3160, f4 = 4430), vocalTract = 14, attackLen = 50, rolloff = c(-8, -7), mouthAnchors = c(.5, .6, .5), noiseAnchors = data.frame(time = c(0, 400, 450), value = c(-40, -40, -80) + 10), rolloffNoise = -9, play = TRUE, invalidArgAction = 'ignore', plot = T, temperature = .001)
seewave::meanspec(F1_neutralLow, f = 16000, dB = 'max0')
seewave::savewav(F1_neutralLow, f = 16000, filename = paste0(path, 'F1_neutralLow.wav'))
system("ffmpeg -i /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/F1_neutralLow.wav -b:a 128k /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/F1_neutralLow.mp3")

s2 = seewave::spec(F1_neutralLow, f = 16000, dB = NULL)
w = s2[, 2] / sum(s2[, 2])
sum(s2[, 1] * w) * 1000  # spectral centroid = 1463 Hz
