source('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr11/00_master.R')
library(soundgen)
library(seewave)

path = '/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/'

## VISUAL
# same as in F1_a.R


## AUDITORY
F2_high = soundgen(sylLen = 350, pitchAnchors = c(160, 200, 160), formants = list(f1 = 630, f2 = 2680, f3 = 3160, f4 = 4430), vocalTract = 14, attackLen = 50, rolloff = -9, mouthAnchors = c(.5, .6, .5), noiseAnchors = data.frame(time = c(0, 400, 450), value = c(-40, -40, -80) + 10), rolloffNoise = -9, play = TRUE, invalidArgAction = 'ignore', plot = T, temperature = .001)

F2_low = soundgen(sylLen = 350, pitchAnchors = c(160, 200, 160), formants = list(f1 = 630, f2 = 1340, f3 = 3160, f4 = 4430), vocalTract = 14, attackLen = 50, rolloff = -6, mouthAnchors = c(.5, .6, .5), noiseAnchors = data.frame(time = c(0, 400, 450), value = c(-40, -40, -80) + 10), rolloffNoise = -9, play = TRUE, invalidArgAction = 'ignore', plot = T, temperature = .001)

seewave::meanspec(F2_high, f = 16000, dB = 'max0')
seewave::meanspec(F2_low, f = 16000, dB = 'max0')

# an1 = analyze(F2_high, samplingRate = 16000, plot = F, summary = T)
# an1$meanFreq_median
# an1$specSlope_median * 10000
# an2 = analyze(F2_low, samplingRate = 16000, plot = F, summary = T)
# an2$meanFreq_median
# an2$specSlope_median * 10000
# note: basically impossible to equalize spectral centroids or even slopes if F2 changes so much! But we can equalize the amount of E at 6-8 kHz

# dynamic sounds: F2 changes by ±6 semitones
F2_neutralHigh = soundgen(sylLen = 350, pitchAnchors = c(160, 200, 160), formants = list(f1 = 630, f2 = c(1900, 2680), f3 = 3160, f4 = 4430), vocalTract = 14, attackLen = 50, rolloff = c(-7.5, -9), mouthAnchors = c(.5, .6, .5), noiseAnchors = data.frame(time = c(0, 400, 450), value = c(-40, -40, -80) + 10), rolloffNoise = -9, play = TRUE, invalidArgAction = 'ignore', plot = T, osc = T, temperature = .001)
# amplitude correction
F2_neutralHigh = F2_neutralHigh * .81  # in dB: log10(.81) * 20
seewave::meanspec(F1_neutralHigh, f = 16000, dB = 'max0')
seewave::savewav(F2_neutralHigh, f = 16000, filename = paste0(path, 'F2_neutralHigh.wav'))
system("ffmpeg -i /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/F2_neutralHigh.wav -b:a 128k /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/F2_neutralHigh.mp3")

s1 = seewave::spec(F2_neutralHigh, f = 16000, dB = NULL)
w = s1[, 2] / sum(s1[, 2])
sum(s1[, 1] * w) * 1000  # spectral centroid = 1659 Hz


F2_neutralLow = soundgen(sylLen = 350, pitchAnchors = c(160, 200, 160), formants = list(f1 = 630, f2 = c(1900, 1340), f3 = 3160, f4 = 4430), vocalTract = 14, attackLen = 50, rolloff = c(-7.5, -6), mouthAnchors = c(.5, .6, .5), noiseAnchors = data.frame(time = c(0, 400, 450), value = c(-40, -40, -80) + 10), rolloffNoise = -9, play = TRUE, invalidArgAction = 'ignore', plot = T, osc = T, temperature = .001)
seewave::savewav(F2_neutralLow, f = 16000, filename = paste0(path, 'F2_neutralLow.wav'))
system("ffmpeg -i /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/F2_neutralLow.wav -b:a 128k /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/F2_neutralLow.mp3")

s2 = seewave::spec(F2_neutralLow, f = 16000, dB = NULL)
w = s2[, 2] / sum(s2[, 2])
sum(s2[, 1] * w) * 1000  # spectral centroid = 1369 Hz
