setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13')
source('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/00_master.R')
library(soundgen)
library(seewave)

path = '/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/'

## VISUAL
s = sliceLab(list(a = 0, b = 0))
s = sliceLab(constraints = list(a = 0, b = 0)) 
saveLab(col_lab = c(35, 0, 0), 
        filename = 'L25_a0_b0',
        path = path, width = 800, height = 800)
saveLab(col_lab = c(65, 0, 0), 
        filename = 'L75_a0_b0',
        path = path, width = 800, height = 800)


## AUDITORY
loudLum_01_loud = soundgen(sylLen = 350, pitchAnchors = c(160, 200, 160), formants = NULL, vocalTract = 14, attackLen = 50, rolloff = -9, mouthAnchors = c(.5, .6, .5), noiseAnchors = data.frame(time = c(0, 400, 450), value = c(-40, -40, -80) + 10), rolloffNoise = -9, play = TRUE, invalidArgAction = 'ignore', plot = T, temperature = .001)
seewave::savewav(loudLum_01_loud, f = 16000, filename = paste0(path, 'loudLum_ampl0.wav'))
system("ffmpeg -i /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/loudLum_01_ampl0.wav -b:a 128k /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/loudLum_ampl0.mp3")

s1 = seewave::spec(loudLum_01_loud, f = 16000, dB = NULL)
w = s1[, 2] / sum(s1[, 2])
sum(s1[, 1] * w) * 1000  # spectral centroid = 1252 Hz

dif_dB = 20
loudLum_02_quiet = loudLum_01_loud * 10 ^ (-dif_dB / 20)
seewave::savewav(loudLum_02_quiet, f = 16000, filename = paste0(path, 'loudLum_ampl20.wav'))
system("ffmpeg -i /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/loudLum_ampl20.wav -b:a 128k /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/loudLum_ampl20.mp3")
