setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13')
source('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/00_master.R')
library(soundgen)
library(seewave)

path = '/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/'

## VISUAL
# same as in loudLum.R


## AUDITORY
# raise or lower pitch by sqrt(sqrt(2)) (so the difference between high and low is half an octave) 
pitchLum_high = soundgen(sylLen = 350, pitchAnchors = c(160, 200, 160) * 2^.25, formants = NULL, vocalTract = 14, attackLen = 50, rolloff = -9, mouthAnchors = c(.5, .6, .5), noiseAnchors = data.frame(time = c(0, 400, 450), value = c(-40, -40, -80) + 10), rolloffNoise = -9, play = TRUE, invalidArgAction = 'ignore', plot = T, temperature = .001)
playme(pitchLum_high)
spectrogram(pitchLum_high, samplingRate = 16000, osc = T, ylim = c(0, 8))
seewave::meanspec(pitchLum_high, f = 16000, dB = 'max0')
seewave::savewav(pitchLum_high, f = 16000, filename = paste0(path, 'pitchLum_high.wav'))
system("ffmpeg -i /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/pitchLum_high.wav -b:a 128k /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/pitchLum_high.mp3")

s1 = seewave::spec(pitchLum_high, f = 16000, dB = NULL)
w = s1[, 2] / sum(s1[, 2])
sum(s1[, 1] * w) * 1000  # spectral centroid = 1242 Hz

pitchLum_low = soundgen(sylLen = 350, pitchAnchors = c(160, 200, 160) / 2^.25, formants = NULL, vocalTract = 14, attackLen = 50, rolloff = -9, mouthAnchors = c(.5, .6, .5), noiseAnchors = data.frame(time = c(0, 400, 450), value = c(-40, -40, -80) + 10), rolloffNoise = -9, play = TRUE, invalidArgAction = 'ignore', plot = T, temperature = .001)
# amplitude correction
pitchLum_low = pitchLum_low * .69
seewave::meanspec(pitchLum_low, f = 16000, dB = 'max0')
seewave::savewav(pitchLum_low, f = 16000, filename = paste0(path, 'pitchLum_low.wav'))
system("ffmpeg -i /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/pitchLum_low.wav -b:a 128k /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/pitchLum_low.mp3")

s2 = seewave::spec(pitchLum_low, f = 16000, dB = NULL)
w = s2[, 2] / sum(s2[, 2])
sum(s2[, 1] * w) * 1000  # spectral centroid = 1252 Hz
