setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13')
source('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/00_master.R')
library(soundgen)
library(seewave)

path = '/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/'

## VISUAL
# yellow
x = matrix(col2rgb('yellow'), nrow = 1) / 255
l = convertColor(x, from = 'sRGB', to = 'Lab')
saveLab(col_lab = l, 
        filename = 'L97_a-21_b94',
        path = path, width = 800, height = 800)

# blue
x = matrix(col2rgb('blue'), nrow = 1) / 255
l = convertColor(x, from = 'sRGB', to = 'Lab')
saveLab(col_lab = l, 
        filename = 'L32_a79_b-108',
        path = path, width = 800, height = 800)

## AUDITORY
specCen_high = soundgen(sylLen = 350, pitchAnchors = c(160, 200, 160), formants = NULL, vocalTract = 14, attackLen = 50, rolloff = -3, mouthAnchors = c(.5, .6, .5), play = TRUE, invalidArgAction = 'ignore', plot = T, temperature = .001)
playme(specCen_high)

specCen_low = soundgen(sylLen = 350, pitchAnchors = c(160, 200, 160), formants = NULL, vocalTract = 14, attackLen = 50, rolloff = -13, mouthAnchors = c(.5, .6, .5), play = TRUE, invalidArgAction = 'ignore', plot = T, temperature = .001)
playme(specCen_low)

s_comb = addVectors(specCen_high, 
                    2 * .75 * specCen_low, 
                    insertionPoint = length(specCen_high) + 16000 * .3)
playme(s_comb)  # equalize the subjective loudness

seewave::savewav(specCen_low, f = 16000, filename = paste0(path, 'specCen_low.wav'))
system("ffmpeg -i /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/specCen_low.wav -b:a 128k /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/specCen_low.mp3")

seewave::savewav(specCen_high / 1.5, f = 16000, filename = paste0(path, 'specCen_high.wav'))
system("ffmpeg -i /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/specCen_high.wav -b:a 128k /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/specCen_high.mp3")
