setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13')
source('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/00_master.R')
library(soundgen)
library(seewave)

path = '/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/'

## VISUAL
# same as in F1_a


## AUDITORY
# NB: make the trill more like a real /r/  - no more than 5 glottal pulses, ~40 Hz
trill_TRUE = soundgen(amDep = c(rep(80, 10), rep(0, 25)), 
                      amFreq = 40,
                      rolloff = c(rep(-12, 10), rep(-9, 25)), 
                      sylLen = 350, pitchAnchors = c(160, 200, 160), formants = NULL, vocalTract = 14, attackLen = c(2, 50), mouthAnchors = c(.5, .6, .5), noiseAnchors = data.frame(time = c(0, 400, 450), value = c(-40, -40, -80) + 10), rolloffNoise = -9, play = TRUE, invalidArgAction = 'ignore', plot = T, temperature = .001, osc = T)
playme(trill_TRUE)
spectrogram(trill_TRUE, samplingRate = 16000, windowLength = 20, osc = T, ylim = c(0, 8))
seewave::meanspec(trill_TRUE, f = 16000, dB = 'max0')

trill_FALSE = soundgen(rolloff = c(rep(-12, 10), rep(-9, 25)), 
                       sylLen = 350, pitchAnchors = c(160, 200, 160), formants = NULL, vocalTract = 14, attackLen = c(2, 50), mouthAnchors = c(.5, .6, .5), noiseAnchors = data.frame(time = c(0, 400, 450), value = c(-40, -40, -80) + 10), rolloffNoise = -9, play = TRUE, invalidArgAction = 'ignore', plot = T, temperature = .001, osc = T)
playme(trill_FALSE)
spectrogram(trill_FALSE, samplingRate = 16000, osc = T, ylim = c(0, 8))
seewave::meanspec(trill_FALSE, f = 16000, dB = 'max0')
seewave::savewav(trill_FALSE, f = 16000, filename = paste0(path, 'trill_FALSE.wav'))
system("ffmpeg -i /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/trill_FALSE.wav -b:a 128k /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/trill_FALSE.mp3")

## new and improved
trill_TRUE = soundgen(amDep = c(rep(0, 2), seq(90, 60, length.out = 8), rep(0, 25)), 
                      amFreq = 25,
                      amShape = 0.3,
                      rolloff = c(rep(-15, 10), rep(-9, 25)), 
                      amplAnchors = data.frame(time = c(0, 100, 110, 350),
                                               value = c(0, 0, -15, -15)), # c(rep(0, 10), rep(-15, 25)),
                      sylLen = 350, pitchAnchors = c(160, 200, 160), 
                      formants = list(f1 = 632, f2 = 1896, f3 = 3160, 
                                      f4 = data.frame(freq = c(3300, 3300, 4400, 4400),
                                                      time = c(0, 140, 340, 350))), 
                      vocalTract = 14, 
                      attackLen = c(50, 50), 
                      mouthAnchors = c(.5, .6, .5), 
                      noiseAnchors = data.frame(time = c(0, 100, 110, 400, 450), 
                                                value = c(-40, -40, -55, -55, -95) + 10),
                      rolloffNoise = -9, 
                      temperature = .001, 
                      play = TRUE, invalidArgAction = 'ignore', 
                      plot = T, osc = T)

s1 = seewave::spec(trill_TRUE, f = 16000, dB = NULL)
w = s1[, 2] / sum(s1[, 2])
sum(s1[, 1] * w) * 1000  # spectral centroid = 1443 Hz

trill_FALSE = soundgen(rolloff = -9, # c(rep(-15, 10), rep(-9, 25)), 
                      sylLen = 350, pitchAnchors = c(160, 200, 160), 
                      formants = list(f1 = 632, f2 = 1896, f3 = 3160, 
                                      f4 = data.frame(freq = c(3300, 3300, 4400, 4400),
                                                      time = c(0, 140, 340, 350))), 
                      vocalTract = 14, 
                      attackLen = c(50, 50), 
                      mouthAnchors = c(.5, .6, .5), 
                      noiseAnchors = data.frame(time = c(0, 400, 450), 
                                                value = c(-40, -40, -80) + 10),
                      rolloffNoise = -9, 
                      temperature = .001, 
                      play = TRUE, invalidArgAction = 'ignore', 
                      plot = T, osc = T)

s2 = seewave::spec(trill_FALSE, f = 16000, dB = NULL)
w = s2[, 2] / sum(s2[, 2])
sum(s2[, 1] * w) * 1000  # spectral centroid = 1601 Hz

s_comb = addVectors(trill_TRUE, 
                    trill_FALSE * .75, 
                    insertionPoint = length(specCen_high) + 16000 * .3)
playme(s_comb)  # equalize the subjective loudness

seewave::savewav(trill_TRUE, f = 16000, filename = paste0(path, 'trill_TRUE.wav'))
system("ffmpeg -i /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/trill_TRUE.wav -b:a 128k /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/trill_TRUE.mp3")

seewave::savewav(trill_FALSE * .75, f = 16000, filename = paste0(path, 'trill_FALSE.wav'))
system("ffmpeg -i /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/trill_FALSE.wav -b:a 128k /home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/experiment/stimuli_apr13/stimuli/trill_FALSE.mp3")
